From 7632fe8deb118a8f41b32478bdf86c8b9ae000d1 Mon Sep 17 00:00:00 2001
From: Kalle Olavi Niemitalo <kon@iki.fi>
Date: Sun, 16 May 2010 23:18:36 +0300
Subject: [PATCH 3/3] Disallow buildings in moon craters

Also, set speed=4 only in very difficult tiles, and speed=5 never.
---
 patches/moon.lua |   56 +++++++++++++++++++++++++++---------------------------
 1 files changed, 28 insertions(+), 28 deletions(-)

diff --git a/patches/moon.lua b/patches/moon.lua
index 3f520ba..412815c 100644
--- a/patches/moon.lua
+++ b/patches/moon.lua
@@ -152,63 +152,63 @@ patchType("moon-d37", "patches/moon/d37.png", 2, 2, {
 })
 patchType("moon-mCr01", "patches/moon/mCr01.png", 2, 2, {
  0x0113, 0x0113,
- 0x0014, 0x0014,
+ 0x0093, 0x0093,
 })
 patchType("moon-mCr02", "patches/moon/mCr02.png", 2, 2, {
  0x0113, 0x0113,
- 0x0014, 0x0014,
+ 0x0093, 0x0093,
 })
 patchType("moon-mCr03", "patches/moon/mCr03.png", 2, 2, {
- 0x0014, 0x0015,
- 0x0014, 0x0014,
+ 0x0093, 0x0093,
+ 0x0093, 0x0093,
 })
 patchType("moon-mCr04", "patches/moon/mCr04.png", 2, 2, {
- 0x0013, 0x0014,
- 0x0014, 0x0013,
+ 0x0013, 0x0093,
+ 0x0093, 0x0013,
 })
 patchType("moon-mCr05", "patches/moon/mCr05.png", 4, 2, {
- 0x0015, 0x0113, 0x0113, 0x0015,
- 0x0014, 0x0113, 0x0113, 0x0014,
+ 0x0093, 0x0113, 0x0113, 0x0113,
+ 0x0093, 0x0113, 0x0113, 0x0093,
 })
 patchType("moon-mCr06", "patches/moon/mCr06.png", 4, 2, {
  0x0013, 0x0113, 0x0113, 0x0013,
- 0x0015, 0x0113, 0x0014, 0x0015,
+ 0x0094, 0x0113, 0x0093, 0x0094,
 })
 patchType("moon-mCr07", "patches/moon/mCr07.png", 4, 4, {
  0x0013, 0x0013, 0x0013, 0x0013,
- 0x0014, 0x0113, 0x0113, 0x0015,
- 0x0013, 0x0113, 0x0113, 0x0014,
+ 0x0093, 0x0113, 0x0113, 0x0094,
+ 0x0013, 0x0113, 0x0113, 0x0093,
  0x0013, 0x0013, 0x0013, 0x0013,
 })
 patchType("moon-mCr08", "patches/moon/mCr08.png", 4, 4, {
  0x0013, 0x0013, 0x0013, 0x0013,
- 0x0014, 0x0113, 0x0113, 0x0014,
- 0x0013, 0x0015, 0x0113, 0x0113,
- 0x0013, 0x0013, 0x0014, 0x0014,
+ 0x0093, 0x0113, 0x0113, 0x0093,
+ 0x0013, 0x0094, 0x0113, 0x0113,
+ 0x0013, 0x0013, 0x0093, 0x0093,
 })
 patchType("moon-mCr09", "patches/moon/mCr09.png", 4, 4, {
  0x0113, 0x0113, 0x0113, 0x0113,
- 0x0013, 0x0013, 0x0014, 0x0015,
- 0x0015, 0x0113, 0x0113, 0x0013,
- 0x0015, 0x0113, 0x0113, 0x0013,
+ 0x0013, 0x0013, 0x0093, 0x0094,
+ 0x0094, 0x0113, 0x0113, 0x0013,
+ 0x0094, 0x0113, 0x0113, 0x0013,
 })
 patchType("moon-mCr10", "patches/moon/mCr10.png", 8, 8, {
  0x0013, 0x0013, 0x0013, 0x0013, 0x0013, 0x0013, 0x0013, 0x0013,
- 0x0013, 0x0013, 0x0014, 0x0113, 0x0113, 0x0113, 0x0013, 0x0013,
- 0x0014, 0x0113, 0x0113, 0x0113, 0x0113, 0x0113, 0x0113, 0x0014,
- 0x0014, 0x0113, 0x0113, 0x0113, 0x0113, 0x0113, 0x0113, 0x0014,
- 0x0013, 0x0015, 0x0113, 0x0113, 0x0113, 0x0113, 0x0014, 0x0013,
- 0x0013, 0x0013, 0x0014, 0x0014, 0x0014, 0x0013, 0x0013, 0x0013,
+ 0x0013, 0x0013, 0x0093, 0x0113, 0x0113, 0x0113, 0x0013, 0x0013,
+ 0x0093, 0x0113, 0x0113, 0x0113, 0x0113, 0x0113, 0x0113, 0x0093,
+ 0x0093, 0x0113, 0x0113, 0x0113, 0x0113, 0x0113, 0x0113, 0x0093,
+ 0x0013, 0x0094, 0x0113, 0x0113, 0x0113, 0x0113, 0x0093, 0x0013,
+ 0x0013, 0x0013, 0x0093, 0x0093, 0x0093, 0x0013, 0x0013, 0x0013,
  0x0013, 0x0013, 0x0013, 0x0013, 0x0013, 0x0013, 0x0013, 0x0013,
  0x0013, 0x0013, 0x0013, 0x0013, 0x0013, 0x0013, 0x0013, 0x0013,
 })
 patchType("moon-mCr11", "patches/moon/mCr11.png", 8, 8, {
  0x0013, 0x0013, 0x0013, 0x0013, 0x0013, 0x0013, 0x0013, 0x0013,
- 0x0013, 0x0013, 0x0014, 0x0113, 0x0113, 0x0113, 0x0013, 0x0013,
- 0x0014, 0x0113, 0x0113, 0x0113, 0x0113, 0x0113, 0x0113, 0x0014,
- 0x0014, 0x0113, 0x0113, 0x0113, 0x0113, 0x0113, 0x0113, 0x0014,
- 0x0013, 0x0015, 0x0113, 0x0113, 0x0113, 0x0113, 0x0113, 0x0014,
- 0x0013, 0x0013, 0x0014, 0x0014, 0x0015, 0x0113, 0x0113, 0x0015,
- 0x0013, 0x0013, 0x0013, 0x0013, 0x0013, 0x0014, 0x0014, 0x0013,
+ 0x0013, 0x0013, 0x0093, 0x0113, 0x0113, 0x0113, 0x0013, 0x0013,
+ 0x0093, 0x0113, 0x0113, 0x0113, 0x0113, 0x0113, 0x0113, 0x0093,
+ 0x0093, 0x0113, 0x0113, 0x0113, 0x0113, 0x0113, 0x0113, 0x0093,
+ 0x0013, 0x0094, 0x0113, 0x0113, 0x0113, 0x0113, 0x0113, 0x0093,
+ 0x0013, 0x0013, 0x0093, 0x0093, 0x0094, 0x0113, 0x0113, 0x0094,
+ 0x0013, 0x0013, 0x0013, 0x0013, 0x0013, 0x0093, 0x0093, 0x0013,
  0x0013, 0x0013, 0x0013, 0x0013, 0x0013, 0x0013, 0x0013, 0x0013,
 })
-- 
1.7.1